View Issue Details

IDProjectCategoryView StatusLast Update
0001903WishesMacropublic2014-10-02 18:55
ReporterMaximusAssigned Tovskirdin 
PrioritynormalSeverityfeatureReproducibilityhave not tried
Status closedResolutionfixed 
Product Version3.0 
Target VersionFixed in Version3.0 
Summary0001903: Plugin.Menu(guid,menuGuid)
DescriptionСобстно, надоело макросить вызов плагинов через F11.
предлагаемая функция - аналогична обычному вызову пункта меню плагина, но в обход открытия всего списка и позиционирования куда надо или выбора хоткея
в отличие от callplugin - выполнение макроса не останавливается, как и при F11
позвать плагин откуда он не ожидает - не получится, проверки области такие же как при населении списка F11
TagsNo tags attached.
Build0

Activities

Maximus

2011-10-12 14:21

reporter  

PluginMenu.diff (6,328 bytes)
PluginMenu.diff (6,328 bytes)

JohnDoe

2011-10-12 14:56

updater   bugnote:0007867

А ведь грядёт и ProcessMacroFuncW.
Не будет ли Plugin.Menu избыточным?

vskirdin

2011-10-12 15:05

administrator   bugnote:0007868

что есть первый параметр, что есть второй?
примеры в студию

Maximus

2011-10-12 18:23

reporter   bugnote:0007871

не будет.
каким макаром ты позовешь плаг, который НЕ экспортирует эту функцию, а расчитан только на вызов из меню?

guid и menuGuid - очевидно гуиды в строковом виде из F11 F3
первый - гуид плагина
второй - гуид пункта меню плагина

Maximus

2011-10-12 20:41

reporter   bugnote:0007872

пример - вызвать colorer outliner:

plugin.Menu("D2F36B62-A470-418D-83A3-ED7A3710E5B5","45453CAC-499D-4B37-82B8-0A77F7BD087C") 5

vskirdin

2011-10-13 16:59

administrator   bugnote:0007874

Не нравится мне это название "Plugin.Menu" - смотря на него, ожидаешь появление какого-то плагинового меню.
Надо что-то другое...

А что будет, если у плагина нет "стартового" меню (про второй параметр)?

Плюс к этому... плагин не будет знать, что его вызвали из макроса (OpenCode). Хотя... может это и ненадо.

Помыслил... тогда нужна парная функция - вызов конфигуратора конкретного плагина (по аналогии - есть PluginManager::CommandsMenu и есть PluginManager::Configure).

Maximus

2011-10-13 17:49

reporter   bugnote:0007877

plugin.call(), plugin.configure()?

если плагин не отдает пункт menuGuid в F11 - вызываться он не должен (поправлю)

vskirdin

2011-10-13 21:38

administrator   bugnote:0007880

ок

Maximus

2011-10-14 16:21

reporter   bugnote:0007881

plugin.call(guid,menuGuid)
  может быть вызвана только из тех макрообластей, которые "умеет" плагин
  ускоренный аналог выбора пункта меню из F11
  гуиды берем из F11 F3
    guid - поле 'Plugin GUID'
    menuGuid - поле 'Plugin item GUID'
  плагин и пункт с такими гуидами должны существовать, иначе функция вернет ошибку
Пример - в редакторе вызвать 'Colorer outliner'
  plugin.Call("D2F36B62-A470-418D-83A3-ED7A3710E5B5","45453CAC-499D-4B37-82B8-0A77F7BD087C") 5

plugin.config(guid[,menuGuid])
  может быть вызвана только из панелей
  ускоренный аналог выбора пункта меню из AltShiftF9
  гуиды берем из «Plugins configuration» F3
    guid - поле 'Plugin GUID'
    menuGuid - поле 'Plugin item GUID', поле необязательное, если не указано
               то функция ConfigureW плагина будет вызвана с GUID_NULL, иначе
               проверяется наличие пункта с таким гуидом.

Странность 1. Функции как бы асинхронные, т.к. при открытии диалога/меню плагином продолжается выполнение макроса (чего и хотелось, аналог F11 Enter)
пример - позвать настройку "Far Commands" и включить "Same folders"
plugin.Config("3A2AF458-43E2-4715-AFEA-93D33D56C0C2") Tab Add Enter
финт типа
%i=plugin.Config(...); $if (%i==...
не прокатит, т.к. макрос продолжает выполняться после появляения диалога.
Смысл тогда возвращать из функции вообще что-либо? Наверное отсутствует?

Странность 2. (наверное вытекает из 1)
выполненное в панелях
macro:post %i=eval("plugin.Config(\"3A2AF458-43E2-4715-AFEA-93D33D56C0C2\") Esc"); MsgBox("eval","eval="+%i)
покажет "eval=1", то есть ошибку, хотя все успешно отработало

Maximus

2011-10-14 16:22

reporter  

PluginCall.diff (7,555 bytes)
PluginCall.diff (7,555 bytes)

vskirdin

2011-10-19 14:24

administrator   bugnote:0007910

подумалось...
может callplugin удалить, а у plugin.call сделать первым параметром 0|1 - синхронный|ассинхронный
и четвертым, необязательным - значение (возможно пятым - тип значения).
по поводу пятого - чтобы плагин понимал, что ему подсунули: число, строку или макропоследовательность (которую плагин подсунет фару).

НО! В Коде бага

1. Стартуем ФАР
2. исполняем
macro:post F4 plugin.Call("C941E865-9C29-485C-99B3-0C710940F2D8","ACEF1ACF-2B06-46BD-BBF0-7A841F4CF22C") ShiftRight

получаем выделенный символ вместо нарисованной горизонталной строки.

Теперь F11 и вызываем дравлайн, потом Esc
теперь повторяем п.2

вот теперь "угу", линия нарисована

Это вот к чему:
1. твой патч не учитывает, что плагин не разу не загружался (т.е. он еще не в кеше)
2. неплохо бы вместо дубляжа кода выделить из PluginManager::CallPluginItem и PluginManager::CommandsMenu зерно в отдельную функцию и...

Maximus

2011-10-19 18:11

reporter   bugnote:0007912

багу поправил.

> по поводу пятого - чтобы плагин понимал, что ему подсунули: число, строку или макропоследовательность (которую плагин подсунет фару).
ничего не понял.
какая макропоследовательность? новая предлагаемая фича?
число или строка - макродвижок вроде и без дополнительных параметров может понять

если убирать callplugin - мне видится как-то так:
plugin.call(type,guid[,item])
type - 0|1 - синхронный|ассинхронный
guid - плагин
item - зависит от type
  0: то что в callplugin было
  1: гуид пункта меню. если не указан, будет выполнен первый пункт плагина, если он всего один(!)

JohnDoe

2011-10-19 19:04

updater   bugnote:0007914

Может не убирать callplugin, а просто переименовать покрасивше?

Maximus

2011-10-19 19:38

reporter   bugnote:0007915

чего?

vskirdin

2011-10-19 20:15

administrator   bugnote:0007916

а чем не устраивает plugin.call(0,guid,значение) == callplugin(guid,значение) ?

JohnDoe

2011-10-20 00:25

updater   bugnote:0007919

Не нравится что суть значения приципиально разная, т.е. скрещивается уж с ежом.

Создаётся видимость будто пользователь может выбрать синхроность/асинхронность.
Но ведь "синхронно" можно вызвать только плагины специально под это заточенные.
Имхо это слишком разные вещи чтобы объединять их в 1.

Maximus

2011-10-20 01:25

reporter  

PluginCall2.diff (641,896 bytes)

Maximus

2011-10-20 01:27

reporter  

PluginCall3.diff (7,574 bytes)
PluginCall3.diff (7,574 bytes)

Maximus

2011-10-20 01:28

reporter   bugnote:0007921

PluginCall3.diff - пока только багу поправил с незагруженным плагином

Maximus

2011-10-20 16:44

reporter   bugnote:0007930

> Не нравится что суть значения приципиально разная, т.е. скрещивается уж с ежом.
Наоборот, одинаковая. Суть одна и та же - вызвать плагин.
ты же не предлагаеешь разделить edit.sel на две функции на том основании, что обычные и вертикальные блоки - суть разные вещи.

> Создаётся видимость будто пользователь может выбрать синхроность/асинхронность
Если юзер думать не умеет, фар ему в этом не поможет. У тебя же не создается такая видимость из-за наличия функции callplugin?

imho - callplugin убить, и добавить параметр в plugin.call - самое то

JohnDoe

2011-10-20 18:31

updater   bugnote:0007934

>Если юзер думать не умеет, фар ему в этом не поможет.
Юзер не знает о "синхронности" и "асинхронности", и знать (по хорошему) не должен.
И если фар будет таки принуждать его об этом задумаваться - ничего хорощего в этом нет.

Может я сам чего не понимаю. Зачем вообще юзеру эта "синхронность"?

Maximus

2011-10-20 22:27

reporter   bugnote:0007936

Ладно, пойдем другим путем. Юзеру не нужно знать про функцию callplugin?

> Зачем вообще юзеру эта "синхронность"?
Вот пристал ;)
Забудь про синхронность асинхронность.
Один режим - аналогичен вызову плагина из F11
Второй режим - специфический, о его использовании консультируйтесь с автором плагина или читайте в документации о плагине.
Вот.

Maximus

2011-10-20 22:28

reporter   bugnote:0007937

> И если фар будет таки принуждать его об этом задумаваться - ничего хорощего в этом нет.
Использование макроязыка по определению принуждает задумываться. Не?

max rusov

2011-10-21 01:44

reporter   bugnote:0007939

Если планируется работа в этом направлении, то может стоит сделать так, чтобы синхронный вызов plugin.call мог возвращать любые данные, а не только признак успешности вызова?...

JohnDoe

2011-10-21 10:12

updater   bugnote:0007940

> Юзеру не нужно знать про функцию callplugin?
Лучше бы не знать.

>Забудь про синхронность асинхронность.
Да, так будет лучше.

>Второй режим - специфический, о его использовании...
Вот именно. Он специфический, и поэтому я и предложил не объединять.

>Использование макроязыка по определению принуждает задумываться. Не?
Но ведь не о смысле жизни.
Макроязык он и для домохозяек тоже.

Maximus

2011-10-21 14:52

reporter   bugnote:0007943

> так, чтобы синхронный вызов plugin.call мог возвращать любые данные, а не только признак успешности вызова?...

каким образом фар отличит тип результата: число от строки?
и главное, нафига, если таки будет открыта ProcessMacroFunctionW?

2vskirdin: а почему, кстати, она до сих пор не открыта?

vskirdin

2011-10-21 15:02

administrator   bugnote:0007944

как обычно - работа мешает и фактор времени :-(
после отпуска постараюсь продолжить.

Maximus

2011-10-21 17:03

reporter   bugnote:0007945

Не, я к тому, чего там не хватает для "релиза"?

max rusov

2011-10-21 17:09

reporter   bugnote:0007946

>каким образом фар отличит тип результата: число от строки?

Можно добавить в OpenInfo:

struct FarMacroValue Result;

Недавно делалось подобное - DN_GETVALUE...

>и главное, нафига, если таки будет открыта ProcessMacroFunctionW?

Если будет - то, может и незачем.

Maximus

2011-11-29 03:52

reporter   bugnote:0008000

возвращаясь к нашим баранам...

1. если объединять функции, то все три, вместе с plugin.config
но вот сейчас мне не кажется это хорошей идеей, и дело не в различных действиях ими выполняемых (они все делают одно - передают управление плагину), а в различии параметров. банально сложнее описать использование (например, запутаться в Edit.sel оч.просто)

2. еще мысль. может быть имеет смысл дать возможность вызвать плагин с параметрами?
например:
plugin.call(0,"guid","menu guid") - аналог вызова из F11 (то что сейчас plugin.call делает)
plugin.call(1,"guid","rclk_cmd:Paste C:\") - аналог ввода в ком строке
plugin.call(2,"guid","c:\temp\1.zip") - аналог входа в архив

Maximus

2011-11-29 15:13

reporter   bugnote:0008001

или предлагаемые отдельными функциями оформить?
или все-таки "все в одном" сделать...

SUSim

2011-12-01 19:27

reporter   bugnote:0008028

Скромное имхо: написание макроса с вызовом плагина без простого "F11 и т.д." - УЖЕ требует от писателя этого макроса продвинутости, и разветвлять вызов макросов на те которые доступны из меню, и те которые отдадут ид для калплугин не стоит, лишнее усложнение макроязыка... - я буду вызывать плагин по ГУИД плагина, который вроде как обязателен.

(я бы с удовольствием вызывал плагин макроедит по плугинид, а не по менюид, потому что он недоступен из меню плагинов для диалогов, хотя там ему ни что не мешает работать!)

Maximus

2011-12-02 10:58

reporter   bugnote:0008032

я что-то не понял смысл этого имхо и к чему оно.

Про "макроедит" вообще не в тему. Фар не должен (и не будет) предоставлять возможность вызвать плагин оттуда, откуда он не ожидает. Кроме того, полезность данного плагина в нынешних реалиях вообще под сомнением.

vskirdin

2011-12-09 13:54

administrator   bugnote:0008115

конечный итог какой?

Maximus

2011-12-09 16:16

reporter   bugnote:0008125

хм, вот и мне интересно, какой?
поскольку всем пофиг - доработаю патч как я его вижу, и выложу

JohnDoe

2011-12-09 17:31

updater   bugnote:0008130

Не пофиг.
>банально сложнее описать использование (например, запутаться в Edit.sel оч.просто)
Золотые слова. Очень простой и эффективный критерий: если вам сложно описать, значит и пользователю сложно понять.
Собственно эту мысль я и пытался донести, и именно поэтому не стоит городить монструозные функции.

vskirdin

2011-12-09 17:32

administrator   bugnote:0008132

Как ты его видишь? 1 функция, 2 функции, ... ?

Maximus

2011-12-09 21:46

reporter   bugnote:0008137

склоняюсь к варианту: одна функция на одно действие
т.е. plugin.call/config/cmd/...

только во что переименовать callplugin? IntCall?

SUSim

2011-12-11 18:47

reporter   bugnote:0008138

Last edited: 2011-12-11 18:47

View 2 revisions

читал, думал, склоняюсь к варианту разделения:
plugin.call = F11...
plugin.cfg = F9->Параметры плагинов...
plugin.cmd = Префикс
plugin.Exec = callplugin

Maximus

2012-01-11 01:41

reporter   bugnote:0008357

Следующее приближение
Plugin.Call(Guid[,MenuGuid]) = F11
Plugin.Config(Guid[,MenuGuid]) = F9->Параметры плагинов...
Plugin.Prefix(Guid,Command) = ввод через префикс в комстроке
Plugin.Int(Guid,Item) = алиас callplugin

Первые три - зовут одну CtrlObject->Plugins.CallPluginItem с разными параметрами.
callplugin==Plugin.Int пока не менял, просто добавил алиас (чтобы потом callplugin грохнуть?)

Maximus

2012-01-11 01:41

reporter  

PluginCall4.inf (401 bytes)

Maximus

2012-01-11 01:42

reporter  

PluginCall4.diff (13,873 bytes)
PluginCall4.diff (13,873 bytes)

vskirdin

2012-01-11 11:00

administrator   bugnote:0008365

а почему "Int"?

Maximus

2012-01-11 11:04

reporter   bugnote:0008367

По аналогии с asm-ом. Ну или типа "Internal".
Ничего лучше пока не придумал.

max rusov

2012-01-11 11:34

reporter   bugnote:0008369

Может:
Plugin.call -> Plugin.Open
Plugin.Int -> Plugin.Call

SUSim

2012-01-11 20:38

reporter   bugnote:0008379

Last edited: 2012-01-11 20:41

View 3 revisions

Параметры я, просто, не расписывал... в приближении Maximus они логичны...
Int мне не нравится - Exec лучше :) Open - тем более, не нравится (что значит "открыть"?)

Я бы Plugin.Call поменял бы на Plugin.Run - "запустить плагин и дальше разбирайтесь своими макросами с плагином";
Plugin.Int на plugin.Exec(Guid,Command) - "плагин выполни такую-то команду! и без вопрсов :), просто скажи, в возвращаемом результате, получилось или нет, и если нет, то укажи код причины".

Maximus

2012-01-11 22:39

reporter   bugnote:0008382

По мне, так ".Run" и ".Exec" ассоциируются с командной строкой. Так что оба - не нравятся.
".Open" тоже как-то... Что открыть? А если плагин ничего не открывает? Из редактора, например :)

JohnDoe

2012-02-13 19:20

updater   bugnote:0008560

Last edited: 2012-02-13 19:40

View 4 revisions

Мне нет разницы как будет называться Call/Run/Open.

Но ряд вопросов возникает в связи с Plugin.Prefix.
Зачем? Оно только для панелей или как?
В любом случае название не очень, потому что "префикс" как действие не имеет смысла. Если наша цель передать плагину строку параметров, то лучше назвать это Plugin.Cmdline.

Но помнится такой подход подвергся критике (http://forum.farmanager.com/viewtopic.php?f=15&t=6118).

Я лично не против, но ведь нехорошо если функция будет только в bis?

P.S
И если уж реализовывать, то почему не сразу Exec? http://forum.farmanager.com/viewtopic.php?p=72945#p72945

JohnDoe

2012-02-13 19:41

updater   bugnote:0008562

Last edited: 2012-02-13 20:36

View 2 revisions

Ещё вроде бы решили что callplugin надо не переименовывать, а удавить "заменив на новую всем удобную функцию":
* http://forum.farmanager.com/viewtopic.php?p=75799#p75799
* http://forum.farmanager.com/viewtopic.php?p=76599#p76599

Maximus

2012-02-13 21:22

reporter   bugnote:0008564

На счет "bis". Патч могу хоть сейчас выкатить, но есть у меня смутное подозрение, что там что-то не того случается с макродвижком. Хотя вроде и работает...

> В любом случае название не очень, потому что "префикс" как действие не имеет смысла.
> Если наша цель передать плагину строку параметров, то лучше назвать это Plugin.Cmdline.
Против ".cmdline" ничего не имею. Перечитывать ветку в поиске критики как-то не очень. В текущей версии "Plugin.Prefix" может быть выполнен только тогда, когда доступна командная строка. И, считаю, это правильно. Поэтому не "Exec" - плагин не должен получать управление тогда, когда этого не ожидает.

> Ещё вроде бы решили что callplugin надо не переименовывать, а удавить
Кто решил? Вам бы все давить. ProcessMacroFunctionW похоже еще долго не будет доступна.

NightRoman

2012-02-13 22:21

reporter   bugnote:0008565

Не надо давить callplugin. У меня нормальная работа и механизмы тестирования своей (и неявно Фаровской) кухни все завязаны на callplugin с потрохами.

JohnDoe

2012-02-14 02:06

updater   bugnote:0008567

NightRoman
Я лично ничего не собираюсь давить, а всего лишь обращаю внимание на существование более ранних обсуждений, в которых такие намерения прозвучали от представителя команды, и тогда никто из участников не спорил (а все участники между прочим те же что и здесь).
В любом случае, вначале должна появиться адекватная замена, так что бояться нечего.

JohnDoe

2012-02-14 03:00

updater   bugnote:0008568

Maximus
В таком случае зачем нам вообще ещё один отдельный запуск по префиксу, раз командная строка и так доступна?

Maximus

2012-02-14 03:06

reporter   bugnote:0008569

hint: командная строка может быть и не пустой

JohnDoe

2012-02-14 13:43

updater   bugnote:0008570

Last edited: 2012-02-14 15:11

View 2 revisions

Ctrl-G
А если серьёзно, то опять же предлагаю более универсальный Exec.
Потому что эта функция была по тем же причинам точно так же полезна для запуска всего, а не только плагинов.

Maximus

2012-02-14 23:44

reporter   bugnote:0008571

Я так понял, что про "Ctrl-G" ты несерьезно?

"Exec" есть совершенный офтопик в данном више. Предлагаемый набор функций предназначен для руления конкретным плагином.

JohnDoe

2012-02-15 15:47

updater   bugnote:0008576

Но есть мнение, что функция руления конкретным плагином посредством указания командной строки просто избыточна.

И по функциональности перекрывается гипотетической Exec, которая тут конечно оффтопик, её обсуждаем тут: 0002021 (и на форуме: http://forum.farmanager.com/viewtopic.php?f=15&t=6153)

Maximus

2012-02-15 16:56

reporter   bugnote:0008580

Я бы не сказал, что она избыточна. Есть (будет) комплект функций для руления конкретным плагином. Как-то нелогично делать две "plugin.call" и plugin.config" оставляя "callplugin" и добавляя "гипотетическую" (кто ее делать-то будет?) "Exec".

В общем, свое имхо по юзабилити я высказал. Лично мне была нужна только "plugin.call"

JohnDoe

2012-02-15 19:53

updater   bugnote:0008582

> ...оставляя "callplugin"
Не ясен текущий статус этой функции. Если её планируется оставить (в текущем или доработанном виде), то конечно она должна быть частью этого комплекта функций.
Поднял вопрос на форуме: http://forum.farmanager.com/viewtopic.php?p=90845#p90845

Maximus

2012-03-02 02:49

reporter  

PluginCall5.diff (11,670 bytes)
PluginCall5.diff (11,670 bytes)

Maximus

2012-03-02 02:53

reporter   bugnote:0008661

пятая версия.
Код причесан и допилен до текущего билда фара.
Все вызовы новых функций перенаправлены в новую PluginManager::CallPluginItem
Если плагин показывает только один пункт меню, для функций Plugin.Call и Plugin.Config можно указать только первый параметр - гуид плагина.

Plugin.Int - по желанию, добавлен до кучи как алиас к callplugin. еще один довод к ее названию (если уж переименовать соберетесь) - та же длина что и callplugin, мало ли, может в каком плагине патчить бинарник надо будет...

vskirdin

2012-03-02 09:59

administrator   bugnote:0008668

http://skirda-file.googlecode.com/files/mantis0001903.1.7z

vskirdin

2012-03-02 13:03

administrator   bugnote:0008673

Maximus, сюда бы еще приаттачить патч для вот этого файла:
https://farmanager.com/svn/trunk/enc/enc_rus3.work/meta/macro/macrocmd/prop_func/general.html
с описанием 4-х новых функций

JohnDoe

2012-03-02 13:43

updater   bugnote:0008675

Чего торопиться пока обсуждение этого хозяйства не закончено.
В частности некоторые имена.

Maximus

2012-03-02 17:41

reporter  

PluginCall6.diff (11,648 bytes)
PluginCall6.diff (11,648 bytes)

Maximus

2012-03-06 00:19

reporter  

PluginCall7.diff (11,335 bytes)
PluginCall7.diff (11,335 bytes)

Maximus

2012-03-06 00:20

reporter   bugnote:0008706

так вроде правильнее

vskirdin

2012-03-06 10:23

administrator   bugnote:0008709

Last edited: 2012-03-06 10:29

View 3 revisions

Правильно я понял, что у Plugin.Call, Plugin.Config и Plugin.Prefix предполагается только 2 параметра?

Так же - mmode(3) здесь тоже будет учитывается или нет?
Я вот про это:
int CallPluginRules=1; //GetCurrentCallPluginMode();

И... на будущее :-)
Давайте в массиве intMacroFunction придерживаться алфавитной сортировки...
UPD: а в macroopcode.hpp - добавлять в конец секций


UPD2: и, наверное, в PluginManager::CallPluginItem задействовать Ret/

Maximus

2012-03-06 11:41

reporter   bugnote:0008710

Ну да, только 2. Ведь параметров при вызове пункта меню/настройки конфигурации вообще нет (кроме индекса), а для префикса - только сам префикс.

mmode(3)... я кусок оставил пока, вот только не уверен, что вообще нужно ограничивать плагины в плане макросов (это ведь получается, если "CallPluginRules!=1"?). Идея такая - они ведь не ограничиваются при вызове по хоткею через F11, тут должно быть также.

На счет Ret - я вообще не понимаю... Смысла в данном случае у него imho вообще нет.
Если в макросе написать что-то вроде
%r=Plugin.Call("bla-bla-bla") MsgBox("bla-bla-bla" + %r)
то по идее получится, что
1. при вызове Plugin.Call будет вход в OpenW
2. если плагин "отдаст" управление фару (например диалог/меню покажет), то
3. фар продолжит выполнение макроса. И чему в этом случае будет равен %r?

JohnDoe

2012-03-06 13:12

updater   bugnote:0008711

>вот только не уверен, что вообще нужно ограничивать плагины в плане макросов
У меня идея обратная: по умолчанию ничего не ограничено - mmode(3,1), а если нужно дождаться завершения плагина, то используем mmode(3,0).

>И чему в этом случае будет равен %r?
А зачем нам вообще возвращаемое значение?
При отсутствии плагина фатальная ошибка и всё на этом.

vskirdin

2012-03-06 14:02

administrator   bugnote:0008712

тестируем (на основе PluginCall7.diff)
http://skirda-file.googlecode.com/files/mantis0001903.2.7z
здесь так же mmode(3,1) по умолчанию включен

Maximus

2012-03-06 15:35

reporter   bugnote:0008713

> по умолчанию ничего не ограничено - mmode(3,1), а если нужно дождаться завершения плагина, то используем mmode(3,0).
наверное, это правильно.

> При отсутствии плагина фатальная ошибка и всё на этом
хорошо бы. но смысла нет. хотя... проверить, погонять надо...

JohnDoe

2012-03-06 15:43

updater   bugnote:0008714

>хорошо бы. но смысла нет.
В чём нет смысла?

Maximus

2012-03-07 13:56

reporter  

PluginCall8.diff (11,574 bytes)
PluginCall8.diff (11,574 bytes)

vskirdin

2012-03-07 14:57

administrator   bugnote:0008716

тестируем (на основе PluginCall8.diff)
http://skirda-file.googlecode.com/files/mantis0001903.3.7z
здесь так же mmode(3,1) по умолчанию включен

Maximus

2012-03-12 03:18

reporter  

PluginCall9.diff (12,800 bytes)
PluginCall9.diff (12,800 bytes)

Maximus

2012-03-12 03:20

reporter   bugnote:0008736

Продолжение банкета.
Теперь можно сразу использовать код возврата (Call/Config/Prefix).
1 - плагин/пункт найден, 0 - не найден.

Новые непонятки: http://forum.farmanager.com/viewtopic.php?p=92609#p92609

vskirdin

2012-03-12 12:45

administrator   bugnote:0008744

Тестим
http://skirda-file.googlecode.com/files/mantis0001903.4.7z
2Maximus: патч внутри архива - синхронизируйся со своими сорцами

vskirdin

2012-03-12 14:33

administrator   bugnote:0008746

Я так понимаю, что чем дальше, тем стабильнее и... с логикой определились?
Тогда предлагаю зафиксировать 9-ю версию с моими уточнениями, а дальше отлаживать as is, ибо тестовые билды как то не тестируются (судя по скачиванию)...

Maximus

2012-03-12 16:25

reporter  

Html1.diff (3,496 bytes)
Html1.diff (3,496 bytes)

Maximus

2012-03-12 16:30

reporter   bugnote:0008747

Патч 9.2 меня устраивает. Хелп приложил.

vskirdin

2012-03-12 21:36

administrator   bugnote:0008748

build 2540

zg

2012-03-12 22:50

developer   bugnote:0008749

1. на DMODE_NOPLUGINS проверять разве не надо?
2. что за функция такая Plugin.Int? получить целую часть плагина? не логичней ли Plugin.Call -> Plugin.Menu, Plugin.Int -> Plugin.Call?

Maximus

2012-03-12 22:59

reporter   bugnote:0008750

Last edited: 2012-03-12 23:05

View 2 revisions

zg, на счет Plugin.Menu, который я сначала предлагал :), смотри сюда
http://bugs.farmanager.com/view.php?id=1903#c7874

Plugin.Int - internal, interrupt. не только с целой частью Int ассоциируется.
Если callplugin удалять не будем (а то все грозитесь), то лично мне все-равно как она будет называться. Но если callplugin таки будет грохнут в пользу нового имени - у Plugin.Int "та же длина что и callplugin, мало ли, может в каком плагине патчить бинарник надо будет".

Maximus

2012-03-12 23:05

reporter   bugnote:0008751

> 1. на DMODE_NOPLUGINS проверять разве не надо?

Это не ко мне. В Callplugin он тоже не проверялся.

zg

2012-03-12 23:06

developer   bugnote:0008752

апи ещё не стабилизировано, какие бинарники?

vskirdin

2012-03-13 10:26

administrator   bugnote:0008753

DMODE_NOPLUGINS добавил.
Пошел заниматься переименованием: Plugin.Call -> Plugin.Menu, Plugin.Int -> Plugin.Call

vskirdin

2012-03-13 11:45

administrator   bugnote:0008754

build 2543

Maximus

2012-03-13 14:23

reporter   bugnote:0008755

Очепятка в хелпе.

А может, до кучи, и .Prefix таки переименовать? Например в .Command

ps. Plugin.Exists не по алфавиту :-P

Maximus

2012-03-13 14:50

reporter  

Html2.diff (464 bytes)
Html2.diff (464 bytes)

vskirdin

2012-03-13 15:00

administrator   bugnote:0008756

> А может, до кучи, и .Prefix таки переименовать? Например в .Command
А смысл? Тогда юзеры будут разуметь, что "Command" - для исполнения _всего_

> Plugin.Exists не по алфавиту
где? в macroopcode.hpp? там как бы пофигу, пока пофигу.

в macroopcode.hpp добавлять новое нужно в __конец__ "секций"
"секция" для функций начинается с KEY_MACRO_F_BASE
"секция" булевые переменные - с KEY_MACRO_C_BASE
сделано так для того, чтобы OpCode не изменяли своих значений (для случая, если байткод будет доступен плагнам :-))

DAtaMan

2012-03-13 21:12

reporter   bugnote:0008760

По поводу Plugin.Exists
А если добавить второй параметр - menuGuid?
Может понадобиться. Когда-нибудь... :-)

vskirdin

2012-03-13 23:02

administrator   bugnote:0008763

Когда понадобится, тогда и добавим...

JohnDoe

2012-03-15 11:53

updater   bugnote:0008768

>> А может, до кучи, и .Prefix таки переименовать? Например в .Command
>А смысл? Тогда юзеры будут разуметь, что "Command" - для исполнения _всего_
С чего бы им это так разуметь??
Никто ведь не разумеет что ".Select" в "Menu.Select" позволяет отмечать файлы на панели?

Приставка "Plugin." как бы намекает, не?
Вообще я за Plugin.Cmdline - "передать плагину командную строку"

А Plugin.Prefix как-то невнятно, типа "задать плагину какой-то префикс"

JohnDoe

2012-03-15 13:49

updater   bugnote:0008769

>По поводу Plugin.Exists
Ещё возможна ситуация когда плагин хоть существует, но его вызов из текущей макрообласти не предусмотрен.

vskirdin

2012-03-15 17:40

administrator   bugnote:0008771

Хмм... сейчас это не реализовано. Экзист просто говорит "есть"/"нет" плагин с таким гуидом. Здесь наверное нужен параметр... что-то типа "применим этот плагин к этой области, если такой плагин есть"...

JohnDoe

2012-03-15 18:06

updater   bugnote:0008773

Можно и без параметра, значением
0 - нет плагина
1 - есть но не применим к текущей макрообласти
2 - есть и применим
или 0, -1, 1

P.S.
Что насчёт предыдущего предложения? http://bugs.farmanager.com/view.php?id=1903#c8768

vskirdin

2012-03-20 13:33

administrator   bugnote:0008788

Last edited: 2012-03-20 13:34

View 2 revisions

build 2561
Plugin.Prefix переименован в Plugin.Cmdline

Под Exist заводите другой тикет

JohnDoe

2012-03-20 15:50

updater   bugnote:0008791

В энциклопедии сосуществуют Plugin.Call и Callplugin (причём ещё с SysID).
Как я понимаю Callpugin пора уже убирать. Вначале из Энциклопедии, а потом и из Фара.

vskirdin

2012-03-20 16:33

administrator   bugnote:0008794

в Писании убрал Callplugin.

NightRoman

2012-03-20 18:50

reporter   bugnote:0008795

Назовите, пожалуйста, Plugin.Command, а не Plugin.Cmdline, если это не принципиально по внутренним соображениям. Нет такого слова Cmdline, а Command есть, и это по разным причинам удобно. Конечно, это шашечки.

JohnDoe

2012-03-20 19:40

updater   bugnote:0008796

В фаре такое слово есть: http://google.com/search?q=cmdline%20site:api.farmanager.com

>это по разным причинам удобно
?

NightRoman

2012-03-20 19:55

reporter   bugnote:0008797

Вызов команды плагина к сущности командная строка прямого отношения не имеет. Команду можно вызывать из командной строки. А вот теперь и не только, можно из макроса. А потом еще откуда-то. Ну вам видней.

Maximus

2012-03-27 01:53

reporter   bugnote:0008826

Бага?
MacroLib, комплект с макросом (MacroLib.120326.7z) прилагается.
В панелях нажать, например, RAltA
Вызывается "callplugin", после завершения
if (CtrlObject->Plugins->CallPlugin(guid,OPEN_FROMMACRO,&info,&ResultCallPlugin))
содержимое переменной MR разрушено.

Maximus

2012-03-27 01:54

reporter  

MacroLib.120326.7z (51,245 bytes)

vskirdin

2012-03-28 14:02

administrator   bugnote:0008827

Возможно и баг.
Может какой нибудь тест попроще придумать, нежели MacroLib? Тяжко отлаживать (много отвлечений)...

JohnDoe

2014-06-10 14:49

updater   bugnote:0012496

Вроде бы всё реализовано, и незачем держать открытым?

Связанный тикет: 0002381

Issue History

Date Modified Username Field Change
2011-10-12 14:21 Maximus New Issue
2011-10-12 14:21 Maximus File Added: PluginMenu.diff
2011-10-12 14:56 JohnDoe Note Added: 0007867
2011-10-12 15:05 vskirdin Note Added: 0007868
2011-10-12 18:23 Maximus Note Added: 0007871
2011-10-12 20:41 Maximus Note Added: 0007872
2011-10-13 16:59 vskirdin Note Added: 0007874
2011-10-13 17:49 Maximus Note Added: 0007877
2011-10-13 21:38 vskirdin Note Added: 0007880
2011-10-14 16:21 Maximus Note Added: 0007881
2011-10-14 16:22 Maximus File Added: PluginCall.diff
2011-10-19 14:24 vskirdin Note Added: 0007910
2011-10-19 18:11 Maximus Note Added: 0007912
2011-10-19 19:04 JohnDoe Note Added: 0007914
2011-10-19 19:38 Maximus Note Added: 0007915
2011-10-19 20:15 vskirdin Note Added: 0007916
2011-10-20 00:25 JohnDoe Note Added: 0007919
2011-10-20 01:25 Maximus File Added: PluginCall2.diff
2011-10-20 01:27 Maximus File Added: PluginCall3.diff
2011-10-20 01:28 Maximus Note Added: 0007921
2011-10-20 16:44 Maximus Note Added: 0007930
2011-10-20 18:31 JohnDoe Note Added: 0007934
2011-10-20 22:27 Maximus Note Added: 0007936
2011-10-20 22:28 Maximus Note Added: 0007937
2011-10-21 01:44 max rusov Note Added: 0007939
2011-10-21 10:12 JohnDoe Note Added: 0007940
2011-10-21 14:52 Maximus Note Added: 0007943
2011-10-21 15:02 vskirdin Note Added: 0007944
2011-10-21 17:03 Maximus Note Added: 0007945
2011-10-21 17:09 max rusov Note Added: 0007946
2011-11-29 03:52 Maximus Note Added: 0008000
2011-11-29 15:13 Maximus Note Added: 0008001
2011-12-01 19:27 SUSim Note Added: 0008028
2011-12-02 10:58 Maximus Note Added: 0008032
2011-12-09 13:54 vskirdin Note Added: 0008115
2011-12-09 16:16 Maximus Note Added: 0008125
2011-12-09 17:31 JohnDoe Note Added: 0008130
2011-12-09 17:32 vskirdin Note Added: 0008132
2011-12-09 21:46 Maximus Note Added: 0008137
2011-12-11 18:47 SUSim Note Added: 0008138
2011-12-11 18:47 SUSim Note Edited: 0008138 View Revisions
2012-01-11 01:41 Maximus Note Added: 0008357
2012-01-11 01:41 Maximus File Added: PluginCall4.inf
2012-01-11 01:42 Maximus File Added: PluginCall4.diff
2012-01-11 11:00 vskirdin Note Added: 0008365
2012-01-11 11:04 Maximus Note Added: 0008367
2012-01-11 11:34 max rusov Note Added: 0008369
2012-01-11 20:38 SUSim Note Added: 0008379
2012-01-11 20:38 SUSim Note Edited: 0008379 View Revisions
2012-01-11 20:41 SUSim Note Edited: 0008379 View Revisions
2012-01-11 22:39 Maximus Note Added: 0008382
2012-02-13 19:20 JohnDoe Note Added: 0008560
2012-02-13 19:22 JohnDoe Note Edited: 0008560 View Revisions
2012-02-13 19:32 JohnDoe Note Edited: 0008560 View Revisions
2012-02-13 19:40 JohnDoe Note Edited: 0008560 View Revisions
2012-02-13 19:41 JohnDoe Note Added: 0008562
2012-02-13 20:36 JohnDoe Note Edited: 0008562 View Revisions
2012-02-13 21:22 Maximus Note Added: 0008564
2012-02-13 22:21 NightRoman Note Added: 0008565
2012-02-14 02:06 JohnDoe Note Added: 0008567
2012-02-14 03:00 JohnDoe Note Added: 0008568
2012-02-14 03:06 Maximus Note Added: 0008569
2012-02-14 13:43 JohnDoe Note Added: 0008570
2012-02-14 15:11 JohnDoe Note Edited: 0008570 View Revisions
2012-02-14 23:44 Maximus Note Added: 0008571
2012-02-15 15:47 JohnDoe Note Added: 0008576
2012-02-15 16:56 Maximus Note Added: 0008580
2012-02-15 19:53 JohnDoe Note Added: 0008582
2012-03-02 02:49 Maximus File Added: PluginCall5.diff
2012-03-02 02:53 Maximus Note Added: 0008661
2012-03-02 09:59 vskirdin Note Added: 0008668
2012-03-02 13:03 vskirdin Note Added: 0008673
2012-03-02 13:43 JohnDoe Note Added: 0008675
2012-03-02 17:41 Maximus File Added: PluginCall6.diff
2012-03-06 00:19 Maximus File Added: PluginCall7.diff
2012-03-06 00:20 Maximus Note Added: 0008706
2012-03-06 10:23 vskirdin Note Added: 0008709
2012-03-06 10:26 vskirdin Note Edited: 0008709 View Revisions
2012-03-06 10:29 vskirdin Note Edited: 0008709 View Revisions
2012-03-06 11:41 Maximus Note Added: 0008710
2012-03-06 13:12 JohnDoe Note Added: 0008711
2012-03-06 14:02 vskirdin Note Added: 0008712
2012-03-06 15:35 Maximus Note Added: 0008713
2012-03-06 15:43 JohnDoe Note Added: 0008714
2012-03-07 13:56 Maximus File Added: PluginCall8.diff
2012-03-07 14:57 vskirdin Note Added: 0008716
2012-03-12 03:18 Maximus File Added: PluginCall9.diff
2012-03-12 03:20 Maximus Note Added: 0008736
2012-03-12 12:45 vskirdin Note Added: 0008744
2012-03-12 14:33 vskirdin Note Added: 0008746
2012-03-12 16:25 Maximus File Added: Html1.diff
2012-03-12 16:30 Maximus Note Added: 0008747
2012-03-12 21:36 vskirdin Note Added: 0008748
2012-03-12 21:36 vskirdin Assigned To => vskirdin
2012-03-12 21:36 vskirdin Status new => feedback
2012-03-12 22:50 zg Note Added: 0008749
2012-03-12 22:59 Maximus Note Added: 0008750
2012-03-12 22:59 Maximus Status feedback => assigned
2012-03-12 23:05 Maximus Note Added: 0008751
2012-03-12 23:05 Maximus Note Edited: 0008750 View Revisions
2012-03-12 23:06 zg Note Added: 0008752
2012-03-13 10:26 vskirdin Note Added: 0008753
2012-03-13 11:45 vskirdin Note Added: 0008754
2012-03-13 11:45 vskirdin Status assigned => feedback
2012-03-13 14:23 Maximus Note Added: 0008755
2012-03-13 14:23 Maximus Status feedback => assigned
2012-03-13 14:50 Maximus File Added: Html2.diff
2012-03-13 15:00 vskirdin Note Added: 0008756
2012-03-13 21:12 DAtaMan Note Added: 0008760
2012-03-13 23:02 vskirdin Note Added: 0008763
2012-03-15 11:53 JohnDoe Note Added: 0008768
2012-03-15 13:49 JohnDoe Note Added: 0008769
2012-03-15 17:40 vskirdin Note Added: 0008771
2012-03-15 18:06 JohnDoe Note Added: 0008773
2012-03-20 13:33 vskirdin Note Added: 0008788
2012-03-20 13:33 vskirdin Status assigned => feedback
2012-03-20 13:34 vskirdin Note Edited: 0008788 View Revisions
2012-03-20 15:50 JohnDoe Note Added: 0008791
2012-03-20 16:33 vskirdin Note Added: 0008794
2012-03-20 18:50 NightRoman Note Added: 0008795
2012-03-20 19:40 JohnDoe Note Added: 0008796
2012-03-20 19:55 NightRoman Note Added: 0008797
2012-03-27 01:53 Maximus Note Added: 0008826
2012-03-27 01:53 Maximus Status feedback => assigned
2012-03-27 01:54 Maximus File Added: MacroLib.120326.7z
2012-03-28 14:02 vskirdin Note Added: 0008827
2013-02-03 04:33 alexy Severity minor => feature
2014-06-10 14:49 JohnDoe Note Added: 0012496
2014-10-02 18:55 shmuel Build => 0
2014-10-02 18:55 shmuel Status assigned => closed
2014-10-02 18:55 shmuel Resolution open => fixed
2014-10-02 18:55 shmuel Fixed in Version => 3.0